// Izvlacenje.java - Klasa izvlaenja.

package lutrija2;
import java.awt.*;
import java.awt.event.*;

public class Izvlacenje extends Frame {
  private static final int DUZ = 6;           // Broj tokova.
  Masina masina = new Masina(DUZ);            // Koriena maina.
  Button dgmKreni, dgmStani;                  // Komandna dugmad.
  CheckboxGroup grupa = new CheckboxGroup();  // Grupa radio dugmadi.
  TextArea tksBrojevi;                        // Prikaz izvuenih brojeva.

  private void mozeKreni(boolean da) {        // Upotrebljivost dugmadi.
    dgmKreni.setEnabled( da);
    dgmStani.setEnabled(!da);
  }

  Panel ploKomande() {                        // Ploa komandne dugmadi.
    Panel plo = new Panel();
    plo.add (dgmKreni = new Button("Kreni"));
    dgmKreni.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent d) {
        mozeKreni(false);
        masina.kreni(Integer.parseInt(
          grupa.getSelectedCheckbox().getLabel()
        ));
      }
    });
    plo.add (dgmStani = new Button("Stani"));
    dgmStani.addActionListener(new ActionListener () {
      public void actionPerformed(ActionEvent d) {
        mozeKreni(true);
        tksBrojevi.append(masina.stani() + '\n');
      }
    });
    mozeKreni(true);
    return plo;
  }

  Panel ploRadio() {                          // Ploa radio dugmadi.
    Panel plo = new Panel ();
    for (int i=DUZ; i>0; i--)
      plo.add (new Checkbox(i+"", grupa, i==DUZ));
    return plo;
  }

  Panel ploBrojevi() {                        // Ploa izvuenih brojeva.
    Panel plo = new Panel(new BorderLayout ());
    plo.add(tksBrojevi = new TextArea(1, 7), "Center");
    Button dgm = new Button("Isprazni");
    plo.add(dgm, "South");
    dgm.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent d) {
        tksBrojevi.setText("");
      }
    });
    return plo;
  }

  private void popuniProzor() {               // Popunjavanje prozora.
    add(ploBrojevi(), "East");
    Panel ploca = new Panel(new BorderLayout());
    add(ploca, "Center");
    ploca.add(masina, "North");
    Panel plo = new Panel(new GridLayout(2,1));
    ploca.add(plo, "South");
    plo.add(ploRadio());
    plo.add(ploKomande());
  }

  public Izvlacenje() {                       // Inicijalizacija.
    super("Izvlacenje");
    setSize(300, 180);
    setResizable(false);
    popuniProzor();
    setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent d)
        { masina.unisti (); dispose (); }
    });
  }

  public static void main(String[] varg)      // Glavna funkcija.
    { new Izvlacenje(); }
}
