// Automobil.java - Klasa automobila.

package parkiranje;

public class Automobil extends Thread {
  private static int posId = 0;                 // Poslednji identifikator.
  private int id = ++posId;                     // Identifikator automobila.
  private String marka;                         // Marka automobila.
  private Parking park;                         // Korieni parking.
  private int t;                                // Trajanje parkiranja.
  
  public Automobil(String m, Parking p, int tmin, int tmax) {
    marka = m; park = p;                         // Inicijalizacija.
    t = (int)(tmin + Math.random()*(tmax+tmin)); 
    start();
  }
  
  public void run() {                           // Telo niti.
    try {
      park.ulazi(this);
      sleep(t);
      park.izlazi(this);
    } catch (InterruptedException g) {}
  }
  
  public void unisti() { interrupt(); }         // Prekidanje niti.
  
  public String toString()                      // Tekstualni opis.
    { return id + "/" + marka; }
}
