// GraPark.java - Klasa parkinga s grafikim interfejsom.

package parkiranje;
import java.awt.*;

public class GraPark extends Parking {
  private Panel ploca;                  // Prikaziva parkinga.
  private Button[] dugmad;              // Prikazivai mesta za parkiranje.
  
  public GraPark(int kap, int minU, int maxU, int minP, int maxP, int kol) {
    super(kap, minU, maxU, minP, maxP);         // Inicijalizacija.
    ploca = new Panel(new GridLayout(0,kol));
    ploca.setEnabled(false);
    dugmad = new Button [kap];
    for (int i=0; i<kap;
       ploca.add(dugmad[i++] = new Button()));
  }
  
  public Panel ploca() { return ploca; }        // Dohvatanje prikazivaa.

  public synchronized void ulazi(Automobil a) throws InterruptedException
    { super.ulazi(a); prikazi(); }              // Ulazak automobila.

  public synchronized void izlazi(Automobil a)  // Izlazak automobila. 
    { super.izlazi(a); prikazi(); }

  private void prikazi() {                      // Prikazivanje parkinga.
    try {
      for (int i=0; i<dugmad.length; i++) {
        Automobil a = automobil(i);
        dugmad[i].setLabel(a==null ? "" : a.toString());
      }
    } catch (GIndeks g) {};
  }
}
