// Parking.java - Klasa parkinga.

package parkiranje;

public class Parking {
  private Automobil[] mesta; // Mesta za parkiranje.
  private int kap, broj = 0; // Kapacitet i broj zauzetih mesta.
  private Ulaz ulaz;         // Ulaz u parkiranje.

  public Parking(int k, int minU, int maxU, int minP, int maxP) {
    mesta = new Automobil [kap = k];             // Inicijalizacija.
    ulaz = new Ulaz(this, minU, maxU, minP, maxP);
  }
  
  Ulaz ulaz() { return ulaz; }                   // Dohvatanje ulaza.

  public synchronized void ulazi(Automobil a) throws InterruptedException {
    while (broj == kap) wait();                  // Ulazak automobila.
    int i = 0; while (mesta[i] != null) i++;
    mesta[i] = a;
    broj++;
  }
  
  public synchronized void izlazi(Automobil a) { // Izlazak automobila.
    int i = 0; while (i<kap && mesta[i]!=a) i++;
    if (i != kap) { mesta[i] = null; broj--; }
    notifyAll();
  }

  public synchronized Automobil automobil(int i) throws GIndeks {
    if (i<0 || i>=mesta.length)                  // Dohvatanje automobila.
      throw new GIndeks();
    return mesta[i];
  }
  
  public synchronized void otvori()              // Otvaranje parkinga.
    { ulaz.otvori(); }
  
  public synchronized void zatvori()             // Zatvaranje parkinga.
    { ulaz.zatvori(); }
  
  public synchronized void unisti() {            // Unitavanje parkinga.
    ulaz.unisti();
    while (broj > 0) try { wait(); } catch (InterruptedException g) {}
  }
}
