// Parkiranje.java - Organizovanje rada parkinga..

package parkiranje;

import java.awt.*;
import java.awt.event.*;

public class Parkiranje extends Frame {
  
  private GraPark park =                        // Korieni parking.
    new GraPark(10, 200, 500, 1000, 5000, 3);
  Button dgmOtvori  = new Button("Otvori"),     // Upravljaka dugmad.
         dgmZatvori = new Button("Zatvori"),
         dgmUnisti  = new Button("Unisti");
  TextArea tksMarke =                           // Prostor za unos modela.
    new TextArea("BMW\nVW\nOPEL", 1, 6);
  
  private void popuniProzor() {                 // Popunjavanje prozora.
    add(park.ploca(), "Center");
    add(tksMarke, "West");
    Panel plo = new Panel();
    add(plo, "South");
    plo.add(dgmOtvori);
    dgmOtvori.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent d) {
        dgmOtvori.setEnabled(false);
        dgmZatvori.setEnabled(true);
        park.ulaz().postavi(tksMarke.getText().split("\n"));
        park.otvori(); 
      }
    });
    plo.add(dgmZatvori).setEnabled(false);
    dgmZatvori.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent d) { 
        dgmOtvori.setEnabled(true);
        dgmZatvori.setEnabled(false);
        park.zatvori();
      }
    });
    plo.add(dgmUnisti);
    dgmUnisti.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent d) { new Unisti().start(); }
    });
  }

  private Parkiranje() {                        // Inicijalizacija.
    super("Parking");
    setSize(270, 150);
    popuniProzor(); setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent d) { new Unisti().start(); }
    });
  }
  
  private class Unisti extends Thread {         // Niz za unitavanje
    public void run() {                         //   parkinga.
      dgmOtvori.setEnabled(false);
      dgmZatvori.setEnabled(false);
      dgmUnisti.setEnabled(false);
      park.unisti(); dispose();
    }
  }
  
  public static void main(String[] varg)        // Glavna funkcija.
    { new Parkiranje(); }
}
