// Planinarenje.java - Parkiranje za organizovanje planinarenja.

package planinarenje;
import java.awt.*;
import java.awt.event.*;

public class Planinarenje extends Frame {
  private static final int brVod = 5, tDol = 500,   // Parametri rada.
                         maxPlan = 5, tTura = 3000;
  private Drustvo dru = new Drustvo(brVod, tDol);   // Planinarsko drutvo.
  
  private void popuniProzor() {                     // Popunjavanje prozora:
    Panel plo = new Panel(new GridLayout(1,2));
    add(plo, "Center"); plo.add(dru.dohvPrik());
    Panel p = new Panel(new GridLayout(0, 1));
    plo.add(p);
    try {
      for (int i=0; i<brVod; i++) {
        Vodic v = new Vodic(dru, maxPlan, tTura);
        dru.dodaj(v); p.add(v.dohvPrik());
      }
    } catch (GPuno g) {};
    add(plo = new Panel(), "South");
    plo.setBackground(Color.LIGHT_GRAY);
    Button dgm = new Button("Otvori"); plo.add(dgm);
    dgm.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent d)
        { dru.otvori(); }
    });
    plo.add(dgm = new Button("Zatvori"));
    dgm.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent d)
        { dru.zatvori(); }
    });    
  }
  
  private Planinarenje () {                         // Inicijalizacija.
    super("Planinarenje"); setSize(200, 180);
    popuniProzor(); setVisible(true);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent d)
        { dru.unisti(); dispose(); }
    });
  }
  
  public static void main(String[] varg)            // Glavna funkcija.
    { new Planinarenje(); }
}
