// Vodic.java - Klasa planinarskih vodia.

package planinarenje;
import java.awt.Label;

public class Vodic extends Thread {
  private static int posId = 0;       // Poslednji identifikator.
  private int id = ++posId;           // Identifikator vodia.
  private Drustvo dru;                // Planinarsko drutvo.
  private int maxPlan, brPlan;        // Najvei i trenutni broj turista.
  private int tSrTura;                // Srednje trajanje ture.
  private String smer;                // Oznaka smera kretanja.
  private Label prikaz = new Label(); // Prikaziva vodia.
  private volatile boolean radi = false; // Da li vodi radi?
  
  public Vodic(Drustvo d, int mP, int tS)      // Inicijalizacija.
   { dru = d; tSrTura = tS; maxPlan = mP; start(); }
  
  public int dohvId() { return id; }           // Dohvatanje identifikatora.
  
  public synchronized void kreni()             // Polazak vodia.
    { radi = true; notify(); }
  
  public void stani() { radi = false; }        // Zaustavljanje vodia.
  
  public void unisti() { interrupt(); }        // Prekidanje niti vodia.
  
  public void run() {                          // Telo niti.
    try {
      while (!interrupted()) {
        smer = ""; brPlan = 0; prikazi();
        synchronized (this) { if (!radi) wait(); }
        while (brPlan<maxPlan && dru.uzmiPlan(this)) {
          brPlan++; 
          prikazi();
        }
        if (brPlan > 0) {
          smer = "==>"; prikazi(); sleep(dt());
          smer = "<=="; prikazi(); sleep(dt());
        }
      }
    } catch (InterruptedException g) {}
  }
                                               // Trajanje ture.
  private long dt() { return (long)((0.8 + Math.random()*0.4) * tSrTura); }
  
  private void prikazi() {                     // Prikazivanje vodia.
    String s = id + ": " + brPlan + " " + smer;
    prikaz.setText(s);
  }
  
  public Label dohvPrik() { return prikaz; }   // Dohvatanje prikazivaa.
}
