// Vektor.java - Klasa vektora u prostoru.

package pokretni;

public class Vektor {

  private double x, y, z;                        // Komponente vektora.

  public Vektor() {}                             // Inicijalizacija.

  public Vektor(double xx, double yy, double zz)
    { x = xx; y = yy; z = zz; }

  public double intenzitet()                     // Intenzitet.
    { return Math.sqrt(x*x + y*y + z*z); }

  public Vektor zbir(Vektor v)                   // this + v
    { return new Vektor(x+v.x, y+v.y, z+v.z); }

  public Vektor proizvod(double s)               // this * s
    { return new Vektor(x*s, y*s, z*s); }

  public String toString()                       // Tekstualni opis.
    { return "(" + x + "," + y + "," + z + ")"; }
}