// Kamion.java - Klasa kamiona.

package prevoz;

public class Kamion implements Merljiv {
  
  private double sopTezina, nosivost; // Sopstvena teina i nosivost.
  private double teret = 0;           // Teina tereta.
  private Elem prvi, posl;            // Prvi i poslednji element liste.
  
  private class Elem {                // Element liste paketa:
    Paket pak;                        // - sadrani paket,
    Elem sled = null;                 // - sledei element liste, 
    
    Elem(Paket p) {                   // - konstruktor.
      pak = p; sled = null;
      if (prvi==null) prvi=this; else posl.sled=this;
      posl = this;
    }
  }
  
  public Kamion(double sT, double n)            // Inicijalizacija.
    { sopTezina = sT; nosivost = n; }
  
  public Kamion dodaj(Paket p) throws GTeret {  // Dodavanje paketa.
    if (teret+p.tezina() > nosivost) throw new GTeret();
    new Elem( p); teret += p.tezina();
    return this;
  }

  public double tezina() { return sopTezina + teret; } // Teina kamiona.

  public double vrednost() {                    // Vrednost tereta.
    double v = 0;
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      v += tek.pak.vrednost();
    return v;
  }

  public String toString() {                    // Tekstualni opis.
    String s = "Kamion(" + nosivost + "," + sopTezina + ","
                         + tezina() + "," + vrednost() + ")";
    for (Elem tek=prvi; tek!=null; tek=tek.sled)
      s += "\n" + tek.pak;
    return s;
  }
}
