// Teret.java - Apstraktna klasa tereta.

package vozovi;

public abstract class Teret {
  
  private static int posId = 0;        // Poslednji identifikator.
  private int id;                      // Identifikator tereta.
  private double sigma;                // Specifina teina.

  Teret(double s)                      // Nov objekat dobija nov ident.
    { id = ++posId; sigma = s; }

  public abstract char vrsta();        // Oznaka vrste.
  
  public abstract double zapr();                         // Zapremina.
  
  public double tezina() { return zapr() * sigma; }      // Teina.
  
  public String toString() { return "" + vrsta() + id; } // Tekst. opis.
}
