// Voz.java - Klasa vozova.

package vozovi;

public class Voz {

  Niz<Vozilo> vozila;                           // Niz vozila.

  public Voz(int k) { vozila = new Niz<Vozilo>(k); } // Inicijalizacija.
  
  public int duzina()                           // Duina voza.
    { return vozila.duzina(); }

  public boolean preopt(Vozilo v) {             // Da li bi se preopteretio?
    double teret = 0, snaga = 0;
    try {
      for (int i=0; i<vozila.duzina(); i++) {
        Vozilo w = vozila.dohvati(i);
        teret += w.ukTezina();
        snaga += w.vucnaSnaga();
      }
    } catch (GIndeks g) {}
    return teret + v.ukTezina() > snaga + v.vucnaSnaga();
  }
  
  public Voz dodaj(Vozilo v) throws GPreopt, GPun { // Dodavanje vozila.
    if (preopt(v)) throw new GPreopt();
    vozila.dodaj(v);
    return this;
  }

  public String toString() {                    // Tekstualni opis.
    StringBuilder s = new StringBuilder();
    try {
      for (int i=0; i<vozila.duzina(); i++)
        s.append(vozila.dohvati(i)).append("\n");
    } catch (GIndeks g) {}
    return s.toString();
  }
}
